import React, { useState, useEffect, Fragment } from 'react';
import { NotificationManager, NotificationContainer } from 'react-notifications';
import { useLocation, useNavigate, BrowserRouter, Routes, Route } from 'react-router-dom';
import axios from 'axios';
import { useTranslation } from 'react-i18next';

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function removeLangFromPathName(lang, pathname) {
  if (lang === 'en') return pathname;
  var prefix = '/' + lang;

  if (pathname.startsWith(prefix)) {
    return pathname.substr(prefix.length);
  }

  return pathname;
}
function addLangToPathName(lang, pathname) {
  if (lang === 'en') return pathname;
  return '/' + lang + pathname;
}
function useApi(url) {
  var _useState = useState(),
      result = _useState[0],
      setResult = _useState[1];

  var _useState2 = useState(false),
      loading = _useState2[0],
      setLoading = _useState2[1];

  for (var _len = arguments.length, params = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    params[_key - 1] = arguments[_key];
  }

  useEffect(function () {
    console.log('will reload');
    setLoading(true);
    setResult(null);
    axios.get(url).then(function (r) {
      setResult(r.data);
      setLoading(false);
    });
  }, [url].concat(params));
  return [result, loading, setResult];
}
var mainComponents = {};

var MainWrapper = function MainWrapper(_ref) {
  var result = _ref.result,
      onChange = _ref.onChange;
  var Component = mainComponents[result === null || result === void 0 ? void 0 : result.template];
  return /*#__PURE__*/React.createElement(Fragment, null, Component && result && /*#__PURE__*/React.createElement(Component, _extends({}, result, {
    onChange: onChange
  })));
};

var wrapperComponents = {
  MainWrapper: MainWrapper
};

var default_result_worth_processing = function default_result_worth_processing(_ref2) {
  var result = _ref2.result,
      navigate = _ref2.navigate;

  if (result !== null && result !== void 0 && result.notification) {
    NotificationManager[result.notification.type]('', result.notification.text);
  }

  if (result !== null && result !== void 0 && result.redirect) {
    window.location.href = result.redirect;
    return false;
  }

  if (result !== null && result !== void 0 && result.navigate) {
    navigate(result.navigate);
    return false;
  }

  return true;
};

var gatherFileUids = function gatherFileUids(data) {
  if (Array.isArray(data)) return data.reduce(function (a, b) {
    return _extends({}, a, gatherFileUids(b));
  }, null);

  if (data && typeof data === 'object') {
    if (data.its_uid_for_file_to_upload_239r8h239rh239r) {
      var _ref3;

      var uid = data.its_uid_for_file_to_upload_239r8h239rh239r;
      return _ref3 = {}, _ref3[uid] = window[uid].file, _ref3;
    }

    return Object.entries(data).reduce(function (a, _ref4) {
      var b = _ref4[1];
      return _extends({}, a, gatherFileUids(b));
    }, null);
  }
};

var BaseLayout = function BaseLayout(_ref5) {
  var result_worth_processing_fn = _ref5.result_worth_processing_fn;
  var result_worth_processing = result_worth_processing_fn || default_result_worth_processing;
  var loc = useLocation();
  var navigate = useNavigate();
  var lang = window.CURRENT_LANGUAGE || 'en';

  var _useTranslation = useTranslation(),
      i18n = _useTranslation.i18n;

  useEffect(function () {
    i18n.changeLanguage(lang);
  }, [i18n.resolvedLanguage === lang]);
  var apiUrl = addLangToPathName(lang, "/api" + removeLangFromPathName(lang, loc.pathname + loc.search));

  var _useApi = useApi(apiUrl, loc.key),
      result = _useApi[0];

  useEffect(function (_) {
    console.log('GET API returned', result, window.actionToConsume);
    if (result !== null && result !== void 0 && result.current_date) window.current_date = result.current_date;
    if (!result_worth_processing({
      result: result,
      loc: loc,
      navigate: navigate
    })) return;
  }, [result]);

  var onChange = function onChange(data, setErrors, customHandler) {
    try {
      var _temp3 = function _temp3() {
        var result = resp.data;
        console.log('POST API returned', resp);

        if (customHandler) {
          customHandler(result);
        } else {
          if (setErrors) setErrors(null, null);
          if (!result_worth_processing({
            result: result,
            loc: loc,
            navigate: navigate
          })) return;

          if ((result === null || result === void 0 ? void 0 : result.action) === 'setErrors') {
            if (setErrors) setErrors(result.errors, result.error);
          }

          if ((result === null || result === void 0 ? void 0 : result.action) === 'closeWindow') {
            window.the_msg = result === null || result === void 0 ? void 0 : result.the_msg;
            window.close();
          }
        }

        return resp.data;
      };

      var resp;

      var _temp4 = function () {
        if (window._react_form_has_files) {
          var formData = new FormData();

          for (var _i = 0, _Object$entries = Object.entries(gatherFileUids(data)); _i < _Object$entries.length; _i++) {
            var _Object$entries$_i = _Object$entries[_i],
                k = _Object$entries$_i[0],
                v = _Object$entries$_i[1];
            formData.append(k, v);
          }

          formData.append('data', JSON.stringify(data));
          return Promise.resolve(axios.post(apiUrl, formData)).then(function (_axios$post) {
            resp = _axios$post;
          });
        } else {
          return Promise.resolve(axios.post(apiUrl, {
            data: data
          })).then(function (_axios$post2) {
            resp = _axios$post2;
          });
        }
      }();

      return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(_temp3) : _temp3(_temp4));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  var Wrapper = wrapperComponents[result === null || result === void 0 ? void 0 : result.wrapper];
  if (result !== null && result !== void 0 && result.navigate || !Wrapper) return /*#__PURE__*/React.createElement("div", null);
  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(Wrapper, {
    loc: loc,
    navigate: navigate,
    result: result,
    apiUrl: apiUrl,
    onChange: onChange
  }));
};

function App() {
  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(BrowserRouter, null, /*#__PURE__*/React.createElement(Routes, null, /*#__PURE__*/React.createElement(Route, {
    path: "*",
    element: /*#__PURE__*/React.createElement(BaseLayout, null)
  }))), /*#__PURE__*/React.createElement(NotificationContainer, {
    enterTimeout: 10,
    leaveTimeout: 10
  }));
}

export { App, BaseLayout, addLangToPathName, default_result_worth_processing, gatherFileUids, mainComponents, removeLangFromPathName, useApi, wrapperComponents };
//# sourceMappingURL=index.modern.js.map
